﻿Imports System.Security
Imports System.IO
Imports System.Text

Public Class Form1

    Private Sub btnLocalizar_Click(sender As Object, e As EventArgs) Handles btnLocalizar.Click
        'define as propriedades do controle 
        'OpenFileDialog
        Me.ofd1.Multiselect = True
        Me.ofd1.Title = "Selecionar Arquivo"
        ofd1.InitialDirectory = "C:\dados"
        'filtra para exibir somente arquivos de imagens
        ofd1.Filter = "Texto (*.txt)|*.txt|" + "Todos (*.*)|*.*"
        ofd1.CheckFileExists = True
        ofd1.CheckPathExists = True
        ofd1.FilterIndex = 1
        ofd1.RestoreDirectory = True
        ofd1.ReadOnlyChecked = True
        ofd1.ShowReadOnly = True

        'abre a caixa de diálogo
        Dim dr As DialogResult = Me.ofd1.ShowDialog()
        If dr = System.Windows.Forms.DialogResult.OK Then
            Try
                'obtem o nome do arquivo texto selecionado
                txtArquivoTexto.Text = ofd1.FileName
                ' cria um PictureBox
            Catch ex As SecurityException
                ' O usuário  não possui permissão para ler arquivos
                MessageBox.Show("Erro de segurança Contate o administrador de segurança da rede." & vbLf & vbLf + "Mensagem : " + ex.Message + vbLf & vbLf + "Detalhes (enviar ao suporte):" & vbLf & vbLf + ex.StackTrace)
            Catch ex As Exception
                ' Ocorreu um erro ao selecionar o arquivo
                MessageBox.Show("Erro : " + ex.Message, "Erro", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If
    End Sub

    Private Sub btnSair_Click(sender As Object, e As EventArgs) Handles btnSair.Click
        Me.Close()
    End Sub

    Private Sub btnCriar_Click(sender As Object, e As EventArgs) Handles btnCriar.Click

        Dim caminho As String = ""
        If Not String.IsNullOrEmpty(txtArquivoTexto.Text) Then
            caminho = txtArquivoTexto.Text
        Else
            MessageBox.Show("Informe o nome do arquivo texto ", "Informe o nome do arquivo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            txtArquivoTexto.Focus()
            Return
        End If

        If Not File.Exists(caminho) Then
            ' Cria um arquivo para escrita
            Using sw As FileStream = File.Create(caminho)
                Dim texto As Byte() = New UTF8Encoding(True).GetBytes("Macoratti .net - Quase tudo para Visual Basic")
                sw.Write(texto, 0, texto.Length)
            End Using
            ' Abre o arquivo para leitura
            Using sr As StreamReader = File.OpenText(caminho)
                rtbTexto.Text = sr.ReadToEnd
            End Using
        Else
            MessageBox.Show("Ja existe um arquivo com esse nome ", "Informe o nome do arquivo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If
    End Sub

    Private Sub btnEscrever_Click(sender As Object, e As EventArgs) Handles btnEscrever.Click

        Dim caminho As String = ""
        If Not String.IsNullOrEmpty(txtArquivoTexto.Text) Then
            caminho = txtArquivoTexto.Text
        Else
            MessageBox.Show("Informe o nome do arquivo texto ", "Nome do arquivo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            txtArquivoTexto.Focus()
            Return
        End If

        If File.Exists(caminho) Then
            Using sw As StreamWriter = New StreamWriter(caminho, True)
                sw.WriteLine()
                sw.WriteLine("Visual Basic")
                sw.WriteLine("http://www.macoratti.net")
                sw.WriteLine("Macoratti .net")
            End Using

            ' Abre o arquivo para leitura
            Using sr As StreamReader = File.OpenText(caminho)
                rtbTexto.Text = sr.ReadToEnd
            End Using
        Else
            MessageBox.Show("Arquivo não encontrado ", "Nome do arquivo", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If
    End Sub

    Private Sub btnLer_Click(sender As Object, e As EventArgs) Handles btnLer.Click
        Dim caminho As String = ""
        If Not String.IsNullOrEmpty(txtArquivoTexto.Text) Then
            caminho = txtArquivoTexto.Text
        Else
            MessageBox.Show("Informe o nome do arquivo texto ", "Informe o nome do arquivo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            txtArquivoTexto.Focus()
            Return
        End If

        If File.Exists(caminho) Then
            Using tr As TextReader = New StreamReader(caminho)
                rtbTexto.Text = tr.ReadToEnd()
            End Using
        Else
            MessageBox.Show("Arquivo não encontrado ", "Nome do arquivo", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If
    End Sub

    Private Sub btnCopiar_Click(sender As Object, e As EventArgs) Handles btnCopiar.Click

        Dim Prompt As String = "Informe o nome e local do arquivo de destino "
        Dim Titulo As String = "Procurar por nome"
        Dim respostaPadrao As String = "c:\dados\testecopia.txt"
        Dim XPos As Integer = 750
        Dim YPos As Integer = 300
        Dim caminhoArquivoDestino As String

        Dim caminho As String = ""
        If Not String.IsNullOrEmpty(txtArquivoTexto.Text) Then
            caminho = txtArquivoTexto.Text
        Else
            MessageBox.Show("Informe o nome do arquivo texto ", "Informe o nome do arquivo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            txtArquivoTexto.Focus()
            Return
        End If

        caminhoArquivoDestino = InputBox(Prompt, Titulo, respostaPadrao, XPos, YPos)

        If Not String.IsNullOrEmpty(caminhoArquivoDestino) Then

            If File.Exists(caminho) Then
                ' Se o arquivo de destino existe deleta
                If File.Exists(caminhoArquivoDestino) Then
                    File.Delete(caminhoArquivoDestino)
                End If
                'copia o arquivo de origem para o destino
                File.Copy(caminho, caminhoArquivoDestino)
                MessageBox.Show("Arquivo copiado com sucesso", "Cópia", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                MessageBox.Show("Arquivo não encontrado ", "Nome do arquivo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If
        Else
            MessageBox.Show("Arquivo de destino inválido ", "Informe o nome e caminho do arquivo de destino", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If

    End Sub

    Private Sub btnMover_Click(sender As Object, e As EventArgs) Handles btnMover.Click

        Dim Prompt As String = "Informe apenas o local do arquivo de destino "
        Dim Titulo As String = "Procurar por nome"
        Dim respostaPadrao As String = "c:\dados\"
        Dim XPos As Integer = 750
        Dim YPos As Integer = 300
        Dim caminhoArquivoDestino As String

        Dim caminho As String = ""
        If Not String.IsNullOrEmpty(txtArquivoTexto.Text) Then
            caminho = txtArquivoTexto.Text
        Else
            MessageBox.Show("Informe o nome do arquivo texto ", "Nome do arquivo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            txtArquivoTexto.Focus()
            Return
        End If

        caminhoArquivoDestino = InputBox(Prompt, Titulo, respostaPadrao, XPos, YPos)

        If Not String.IsNullOrEmpty(caminhoArquivoDestino) Then
            ' Cria um arquivo com nome unico
            Dim fileLocMove As String = caminhoArquivoDestino & "teste1" & System.DateTime.Now.Ticks & ".txt"
            'verifica se o aruqivo origem existe
            If File.Exists(caminho) Then
                'move o arquivo 
                File.Move(caminho, fileLocMove)
                MessageBox.Show("Arquivo movido com sucesso", "Mover arquivo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                MessageBox.Show("Arquivo não encontrado ", "Nome do arquivo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If
        Else
            MessageBox.Show("Arquivo de destino inválido ", "Informe o nome e caminho do arquivo de destino", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If
    End Sub

    Private Sub btnDeletar_Click(sender As Object, e As EventArgs) Handles btnDeletar.Click

        Dim caminho As String = ""
        If Not String.IsNullOrEmpty(txtArquivoTexto.Text) Then
            caminho = txtArquivoTexto.Text
        Else
            MessageBox.Show("Informe o nome do arquivo texto ", "Nome do arquivo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            txtArquivoTexto.Focus()
            Return
        End If

        If File.Exists(caminho) Then
            File.Delete(caminho)
            MessageBox.Show("Arquivo deletado com sucesso", "Deletar arquivo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            rtbTexto.Clear()
        Else
            MessageBox.Show("Arquivo não encontrado ", "Informe o nome do arquivo", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If

    End Sub
End Class
